Type typeSprite
	Field x#
	Field y#
	Field oldX#
	Field oldY#
	Field targetX
	Field targetY
	Field followTarget

	Field speedX#
	Field speedY#
	Field targetSpeedX#
	Field targetSpeedY#
	Field speedStep#
	Field speedLimit#
	Field oldSpeedLimit#
	Field speedBrake#
	Field oldSpeedBrake#
	
	Field width
	Field height

	Field frame
	Field frameOffset
	Field frameMax
	Field frameCells
	Field frameCounter
	Field frameCounterMax

	Field animated
	Field imageName$
	Field image

	Field class
	Field classMorphEnergy
	Field oldClass
	
	Field pushedBy
	Field pushedX
	Field pushedY
	Field pushedByMaster
	Field oneDirectionalPusher

	Field ground

	Field counter
	Field energy
	Field pauseAction
	
	Field container
	Field containable
	Field collideable
	Field contained
	
	Field layer
	
	Field master
	;Field mind$
	
	Field born
	Field dying
End Type

Type typeGame
	Field backgroundMusic$
	Field newBackgroundMusic$
	Field animationCounter
	Field animation
	Field fadeOutCounter
	Field musicOn
	Field pause
	Field over
	Field level
	Field newLevel
	Field lifes
	Field restartLevel
End Type

Type typeLevel
	Field exitTop
	Field exitRight
	Field exitBottom
	Field exitLeft
	
	Field backgroundMusic$
End Type

Type typeImageCache
	Field image
	Field fileName$
	Field animation
	Field offset
	Field frames
	Field inited
End Type

Type typeSoundCache
	Field sound
	Field fileName$
	Field inited
End Type

Type typeMap
	Field image
	Field animation
	Field ground
End Type

Const SCREEN_LEFT = 0
Const SCREEN_TOP = 0
Const SCREEN_WIDTH = 640
Const SCREEN_HEIGHT = 480
Const SCREEN_RIGHT = SCREEN_WIDTH-1
Const SCREEN_BOTTOM = SCREEN_HEIGHT-1
Const SCREEN_DEPTH = 16
Const SPRITE_WIDTH = 48
Const SPRITE_HEIGHT = 64
Const TILE_SIZE = 32
Const TILES_X = SCREEN_WIDTH / TILE_SIZE
Const TILES_Y = SCREEN_HEIGHT / TILE_SIZE

Const SHADOW_LEFT =	 -6
Const SHADOW_TOP = 38
Const SHADOW_SMALL_LEFT = -2
Const SHADOW_SMALL_TOP = 10

Const CLASS_PLAYER = 1
Const CLASS_GUARD = 2
Const CLASS_BARRIER = 3
Const CLASS_BULLET = 4
Const CLASS_AIR = 5
Const CLASS_HUNTER = 6
Const CLASS_COWARD = 7
Const CLASS_FOOL = 8
Const CLASS_BALL = 9
Const CLASS_BALL_BOUNCE = 10
Const CLASS_SLIDER_ONCE = 11
Const CLASS_SLIDER_BOUNCE = 12
Const CLASS_SLIDER_RESTART = 13	
Const CLASS_GOD = 14
Const CLASS_DEAD = 15

Const GROUND_WALKABLE = 0
Const GROUND_BARRIER = 1
Const GROUND_DANGER = 2
Const GROUND_GLIDE = 3
Const GROUND_SLOW = 4
Const GROUND_SPEED = 5
Const GROUND_WATER = GROUND_DANGER

Const NO_EVENT = 0
Const EVENT_PLAYER_SHOOTS = 1
Const EVENT_PLAYER_HITS = 2
Const EVENT_PLAYER_EXITS_TOP = 3
Const EVENT_PLAYER_EXITS_RIGHT = 4
Const EVENT_PLAYER_EXITS_BOTTOM = 5
Const EVENT_PLAYER_EXITS_LEFT = 6
Const EVENT_LEVEL_STARTS = 7
Const EVENT_PLAYER_DIES = 8

Const SPRITE_PLAYER = 0
Const SPRITE_PLAYER2 = 1

Const KEY_LEFT = 203
Const KEY_RIGHT = 205
Const KEY_UP = 200
Const KEY_DOWN = 208
Const KEY_ESCAPE = 1
Const KEY_SPACE = 57
Const KEY_LETTER_M = 50
Const KEY_LETTER_P = 25

Const LETTER_WIDTH = 10
Const LETTER_HEIGHT = 20

Const KEY_TOGGLE_MUSIC = KEY_LETTER_M
Const KEY_PAUSE = KEY_LETTER_P

Const PLAYER_KEY_LEFT = KEY_LEFT
Const PLAYER_KEY_RIGHT = KEY_RIGHT
Const PLAYER_KEY_UP = KEY_UP
Const PLAYER_KEY_DOWN = KEY_DOWN
Const PLAYER_KEY_ACTION = KEY_SPACE

Const PLAYER_PAUSE_ACTION = 20

Const LAYER_GROUND = 1
Const LAYER_NEAR_GROUND = 2
Const LAYER_NEAR_SKY = 3
Const LAYER_ALMOST_SKY = 4
Const LAYER_SKY = 5

Const EMPTY_IMAGE = -1
Const ANIMATION_DELAY = 40

Const SPEED_MIN# = .0001

Const DEBUG_LINES = 3
Const LINE_HEIGHT = 18

Const NOBODY = 0
Const NOTHING = -1
Const NO_SPEED# = 50.0
Const NO_LEVEL = 0
Const SPRITE_SMALL_SIZE = 26
Const NO_POSITION = 5000

Const VOLUME_FULL = 1
Const DEFAULT_LIFES = 3
Const DEFAULT_FRAME_COUNTER_MAX = 10
Const MENU_MARGIN = 10

Const COUNTER_END = 0

Const TIMER_FREQUENCY = 40